import 'package:flutter/material.dart';

class LinkField extends StatelessWidget {
  // Le callback `onSaved` est utilisé pour enregistrer la valeur du champ lorsque le formulaire est soumis.
  final FormFieldSetter<String> onSaved;

  // Constructeur de la classe LinkField, qui attend le callback `onSaved`.
  const LinkField({Key? key, required this.onSaved}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    // Création du champ de texte pour le lien
    return TextFormField(
      decoration: InputDecoration(
        labelText: 'Lien (optionnel)', // Le texte affiché lorsqu'il n'y a pas de valeur
        labelStyle: const TextStyle(color: Colors.blueGrey), // Style du texte du label
        filled: true, // Remplissage du champ
        fillColor: Colors.blueGrey.withOpacity(0.1), // Couleur de fond avec une légère opacité
        border: const OutlineInputBorder(
          borderRadius: BorderRadius.all(Radius.circular(10.0)), // Bords arrondis du champ
          borderSide: BorderSide.none, // Pas de bordure visible
        ),
        enabledBorder: OutlineInputBorder(
          borderRadius: BorderRadius.all(Radius.circular(10.0)),
          borderSide: BorderSide(
            color: Colors.blueGrey, // Couleur de la bordure quand non sélectionné
            width: 2.0,
          ),
        ),
        focusedBorder: const OutlineInputBorder(
          borderRadius: BorderRadius.all(Radius.circular(10.0)),
          borderSide: BorderSide(
            color: Colors.blue, // Bordure quand le champ est sélectionné
            width: 2.0,
          ),
        ),
        prefixIcon: const Icon(Icons.link, color: Colors.blueGrey), // Icône de lien à gauche
        hintText: 'Entrez un lien ici...', // Texte d'indication lorsque le champ est vide
      ),
      style: const TextStyle(color: Colors.blueGrey), // Style du texte saisi par l'utilisateur
      onSaved: (value) {
        // Log de la valeur du champ lorsqu'on l'enregistre
        debugPrint("Lien enregistré : $value");

        // Appel du callback `onSaved` pour enregistrer la valeur dans le formulaire
        onSaved(value);
      },
      keyboardType: TextInputType.url, // Permet à l'utilisateur de saisir une URL
      validator: (value) {
        // Si le champ est rempli, on valide que la valeur est bien une URL correcte
        if (value != null && value.isNotEmpty) {
          final Uri? uri = Uri.tryParse(value);
          if (uri == null || !uri.hasAbsolutePath) {
            // Log en cas d'erreur de validation
            debugPrint("URL invalide : $value");
            return 'Veuillez entrer un lien valide';
          }
        }
        return null;
      },
    );
  }
}
